
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include "Messagetypes.h"

#define PI 3.14159

typedef enum message_to_robot_type Mensaje_A_Robot;

float vida=100.0;
int salir=0;
int cuenta=0;
int estado=0;
double distancia, angulo;
int disparos=0;

void Chequea_Mensaje(int sig);
void Gira_Angulo(int que, double velocidad, double angulo);

Mensaje_A_Robot Devuelve_Mensaje(char* mensaje);


int main(void)
{  
   
   signal(SIGUSR1, Chequea_Mensaje);
   printf("RobotOption 2 %d\n",SIGUSR1);
   fflush(stdout);
   while(!salir)
   {/*1:Robot, 2:Caon, 4:Radar
   	printf("Print Estado=%d; Estado Anterior=%d; Tarta=%d; Mina=%d\n",estado,estado_anterior,tarta,mina);
	printf("Print estado=%d\n",estado);*/
	if(estado==0){
		printf("Brake 0\n");
		printf("Accelerate 0.7\n");
		printf("Sweep 6 2 %f %f\n",-PI/6, PI/6);		
	}else if(estado==1){
		
		if(distancia>4 && distancia<6){
			printf("RotateAmount 1 2 %f\n",PI/6);
		}else if (6<distancia){
			printf("Accelerate 0.6\n");
		}else{
			printf("Brake 1\n");
			printf("RotateAmount 1 2 %f\n",PI/3);
		}
			
			
	}else if(estado==2){
		printf("Brake 0\n");
		printf("RotateTo 6 3 0\n");
		printf("RotateAmount 1 3 %f\n",angulo);
		
		
		if(distancia>4){
			if(disparos<5){
				printf("Sweep 6 2 %f %f\n",-PI/36, PI/36);
				printf("Shoot 10\n");
				disparos++;
			}else{
				disparos=0;
				estado=0;
			}
			printf("Accelerate 0.5\n");
		}else{
			if(disparos<8){
				printf("Shoot 20\n");
				disparos++;
			}else{
				disparos=0;
				estado=0;
			}
				
		}
			
		
		
		
	}else if(estado==3||estado==4){
		if(disparos<5){
			printf("Shoot 1\n");
			disparos++;
		}else{
			disparos=0;
			estado=0;
		}
		
	}
				
	fflush(stdout);

	sleep(1);

   }
}

void Chequea_Mensaje(int sig)
{
   static int cuenta=0;
   
   int tipo;
   char mensaje[81];
   while (scanf("%s",mensaje) != EOF)
   {
      Mensaje_A_Robot Recibido;
      Recibido=Devuelve_Mensaje(mensaje);
      switch (Recibido)
      {
         
         
         case INITIALIZE:
              {  int numero;
                 scanf("%d",&numero);
                 if (numero==1)
                { printf("Name FastRTB\n");
                  printf("Colour 22ff22 00dd33\n");
                  fflush(stdout);
                 }
              }
              break;
         
	
	      case ENERGY:
	       {
			scanf("%g",&vida);
			fflush(stdin);
	       }	
		   break;
		 case RADAR:
			{
	    	char sdistancia[20];
			char sangulo[20];
	    	scanf("%s",&sdistancia);
			scanf("%d",&tipo);
			scanf("%s",&sangulo);
			fflush(stdin);
			distancia=atof(sdistancia);
			angulo=atof(sangulo);

			if(tipo==ROBOT){
				if(estado==0){
					estado=2;
				}else if(estado==2){
					cuenta=0;
				}else if(estado==1){
					estado=2;
				}else if(estado==4){
					estado=2;
				}
			}else{ /* contador de mensajes en estado robot (q2) */
				/*if(estado==2){
					cuenta++;
					if(cuenta>=10){
						estado=0;
					}
				}*/
			

				if(tipo==WALL){
					if(estado==0){
						estado=1;
					}else if(estado==1){
						if(4>distancia){
							estado=4;
						}
					}
				}else if(tipo==MINE){
					if(estado==0){
						estado=3;
					}
				}else if(tipo==COOKIE&&40>vida){
					if(estado==0){
						estado=4;
					}
					

				}
			
			}
	   }
	    break;

         case DEAD:
            printf("Kon tan poko tienpo........\n");
            fflush(stdout);
            break;
      }
   }
   signal(sig,Chequea_Mensaje);

}

Mensaje_A_Robot Devuelve_Mensaje(char* mensaje)
{
   int i,valor;
   valor=UNKNOWN_MESSAGE_TO_ROBOT;
   for(i=0; message_to_robot[i].msg[0] != '\0'; i++)
   {
      if(strcmp(message_to_robot[i].msg, mensaje) == 0)
         valor=(Mensaje_A_Robot)i;
   }
   return valor;
}
